diff --git a/contrib/ntp/ntpd/ntp_io.c b/contrib/ntp/ntpd/ntp_io.c
index bb35ffd68511..9d79fe493d9b 100644
--- a/contrib/ntp/ntpd/ntp_io.c
+++ b/contrib/ntp/ntpd/ntp_io.c
@@ -2535,8 +2577,6 @@ socket_multicast_disable(
 # endif
 	struct ip_mreq mreq;
 
-	ZERO(mreq);
-
 	if (find_addr_in_list(maddr) == NULL) {
 		DPRINTF(4, ("socket_multicast_disable(%s): not found\n",
 			    stoa(maddr)));
@@ -2546,6 +2586,7 @@ socket_multicast_disable(
 	switch (AF(maddr)) {
 
 	case AF_INET:
+		ZERO(mreq);
 		mreq.imr_multiaddr = SOCK_ADDR4(maddr);
 		mreq.imr_interface = SOCK_ADDR4(&iface->sin);
 		if (setsockopt(iface->fd, IPPROTO_IP,
@@ -2569,6 +2610,7 @@ socket_multicast_disable(
 		 * for other types of multicast addresses. For now let
 		 * the kernel figure it out.
 		 */
+		ZERO(mreq6);
 		mreq6.ipv6mr_multiaddr = SOCK_ADDR6(maddr);
 		mreq6.ipv6mr_interface = iface->ifindex;
 
@@ -2589,13 +2631,14 @@ socket_multicast_disable(
 	}
 
 	iface->num_mcast--;
-	if (!iface->num_mcast)
+	if (iface->num_mcast <= 0) {
 		iface->flags &= ~INT_MCASTOPEN;
-
+	}
 	return ISC_TRUE;
 }
 #endif	/* MCAST */
 
+
 /*
  * io_setbclient - open the broadcast client sockets
  */
@@ -2705,6 +2748,7 @@ io_setbclient(void)
 #endif	/* OPEN_BCAST_SOCKET */
 }
 
+
 /*
  * io_unsetbclient - close the broadcast client sockets
  */
@@ -2724,10 +2768,7 @@ io_unsetbclient(void)
 			msyslog(LOG_INFO,
 				"stop listening for broadcasts to %s on interface #%d %s",
 				stoa(&ep->bcast), ep->ifnum, ep->name);
-#		    ifdef HAVE_IO_COMPLETION_PORT
-			io_completion_port_remove_socket(ep->bfd, ep);
-#		    endif
-			close_and_delete_fd_from_list(ep->bfd);
+			close_and_delete_fd_from_list(ep->bfd, ep);
 			ep->bfd = INVALID_SOCKET;
 		}
 		ep->flags &= ~INT_BCASTOPEN;
@@ -2735,6 +2776,7 @@ io_unsetbclient(void)
 	broadcast_client_enabled = ISC_FALSE;
 }
 
+
 /*
  * io_multicast_add() - add multicast group address
  */
@@ -2755,9 +2797,6 @@ io_multicast_add(
 
 	/* If we already have it we can just return */
 	if (NULL != find_flagged_addr_in_list(addr, INT_MCASTOPEN)) {
-		msyslog(LOG_INFO,
-			"Duplicate request found for multicast address %s",
-			stoa(addr));
 		return;
 	}
 
@@ -3041,9 +3080,9 @@ open_socket(
 #endif
 		    ) {
 			msyslog(LOG_ERR,
-				"bind(%d) AF_INET%s %s#%d%s flags 0x%x failed: %m",
+				"bind(%d) AF_INET%s %s%s flags 0x%x failed: %m",
 				fd, IS_IPV6(addr) ? "6" : "",
-				stoa(addr), SRCPORT(addr),
+				sptoa(addr),
 				IS_MCAST(addr) ? " (multicast)" : "",
 				interf->flags);
 		}
@@ -3090,9 +3129,8 @@ open_socket(
 	}
 #endif
 
-	DPRINTF(4, ("bind(%d) AF_INET%s, addr %s%%%d#%d, flags 0x%x\n",
-		   fd, IS_IPV6(addr) ? "6" : "", stoa(addr),
-		   SCOPE(addr), SRCPORT(addr), interf->flags));
+	DPRINTF(4, ("bind(%d) addr %s, flags 0x%x\n",
+		    fd, sptoa(addr), interf->flags));
 
 	make_socket_nonblocking(fd);
 
@@ -3123,17 +3161,16 @@ open_socket(
 
 /* XXX ELIMINATE sendpkt similar in ntpq.c, ntpdc.c, ntp_io.c, ntptrace.c */
 /*
- * sendpkt - send a packet to the specified destination. Maintain a
- * send error cache so that only the first consecutive error for a
- * destination is logged.
+ * sendpkt - send a packet to the specified destination from the given endpt
+ *	     except for multicast, which may be sent from several addresses.
  */
 void
 sendpkt(
-	sockaddr_u *		dest,
-	struct interface *	ep,
-	int			ttl,
-	struct pkt *		pkt,
-	int			len
+	sockaddr_u *	dest,
+	endpt *		ep,
+	int		ttl,
+	struct pkt *	pkt,
+	int		len
 	)
 {
 	endpt *	src;
@@ -3145,12 +3182,16 @@ sendpkt(
 	l_fp	org, rec, xmt;
 	
 	ismcast = IS_MCAST(dest);
-	if (!ismcast)
+	if (!ismcast) {
 		src = ep;
-	else
+	} else {
+#ifndef MCAST
+		return;
+#endif
 		src = (IS_IPV4(dest))
-			  ? mc4_list
-			  : mc6_list;
+			? mc4_list
+			: mc6_list;
+	}
 
 	if (NULL == src) {
 		/*
@@ -3164,13 +3205,14 @@ sendpkt(
 	}
 
 	do {
+		if (INT_LL_OF_GLOB & src->flags) {
+			/* avoid duplicate multicasts on same IPv6 net */
+			goto loop;
+		}
 		DPRINTF(2, ("%ssendpkt(%d, dst=%s, src=%s, ttl=%d, len=%d)\n",
 			    ismcast ? "\tMCAST\t***** " : "", src->fd,
 			    stoa(dest), stoa(&src->sin), ttl, len));
 #ifdef MCAST
-		/*
-		 * for the moment we use the bcast option to set multicast ttl
-		 */
 		if (ismcast && ttl > 0 && ttl != src->last_ttl) {
 			/*
 			 * set the multicast ttl for outgoing packets
@@ -3211,7 +3253,7 @@ sendpkt(
 		cc = simulate_server(dest, src, pkt);
 #elif defined(HAVE_IO_COMPLETION_PORT)
 		cc = io_completion_port_sendto(src, src->fd, pkt,
-			(size_t)len, (sockaddr_u *)&dest->sa);
+			(size_t)len, dest);
 #else
 		cc = sendto(src->fd, (char *)pkt, (u_int)len, 0,
 			    &dest->sa, SOCKLEN(dest));
@@ -3223,6 +3265,7 @@ sendpkt(
 			src->sent++;
 			packets_sent++;
 		}
+	    loop:
 		if (ismcast)
 			src = src->mclink;
 	} while (ismcast && src != NULL);
@@ -3241,8 +3284,6 @@ sendpkt(
 			FPTOD(NTOHS_FP(pkt->rootdelay)),
 			FPTOD(NTOHS_FP(pkt->rootdisp)),  pkt->refid,
 			len - MIN_V4_PKT_LEN, (u_char *)&pkt->exten);
-
-	return;
 }
 
 
@@ -3261,7 +3302,7 @@ fdbits(
 	static char buffer[256];
 	char * buf = buffer;
 
-	count = min(count,  255);
+	count = min(count,  sizeof(buffer) - 1);
 
 	while (count >= 0) {
 		*buf++ = FD_ISSET(count, set) ? '#' : '-';
@@ -3334,7 +3375,7 @@ read_refclock_packet(
 	 */
 	rb->recv_length = buflen;
 	rb->recv_peer = rp->srcclock;
-	rb->dstadr = 0;
+	rb->dstadr = NULL;
 	rb->fd = fd;
 	rb->recv_time = ts;
 	rb->receiver = rp->clock_recv;
@@ -3476,9 +3517,9 @@ fetch_timestamp(
  */
 static inline int
 read_network_packet(
-	SOCKET			fd,
-	struct interface *	itf,
-	l_fp			ts
+	SOCKET		fd,
+	endpt *		itf,
+	l_fp		ts
 	)
 {
 	GETSOCKNAME_SOCKLEN_TYPE fromlen;
@@ -3580,23 +3621,14 @@ read_network_packet(
 	** Bug 2672: Some OSes (MacOSX and Linux) don't block spoofed ::1
 	*/
 
-	if (AF_INET6 == itf->family) {
-		DPRINTF(2, ("Got an IPv6 packet, from <%s> (%d) to <%s> (%d)\n",
-			stoa(&rb->recv_srcadr),
-			IN6_IS_ADDR_LOOPBACK(PSOCK_ADDR6(&rb->recv_srcadr)),
-			stoa(&itf->sin),
-			!IN6_IS_ADDR_LOOPBACK(PSOCK_ADDR6(&itf->sin))
-			));
-
-		if (   IN6_IS_ADDR_LOOPBACK(PSOCK_ADDR6(&rb->recv_srcadr))
-		    && !IN6_IS_ADDR_LOOPBACK(PSOCK_ADDR6(&itf->sin))
-		   ) {
-			packets_dropped++;
-			DPRINTF(2, ("DROPPING that packet\n"));
-			freerecvbuf(rb);
-			return buflen;
-		}
-		DPRINTF(2, ("processing that packet\n"));
+	if (   IS_IPV6(&rb->recv_srcadr)
+	    && IN6_IS_ADDR_LOOPBACK(PSOCK_ADDR6(&rb->recv_srcadr))
+	    && !(INT_LOOPBACK & itf->flags)) {
+
+		packets_dropped++;
+		DPRINTF(2, ("DROPPING pkt with spoofed ::1 source on %s\n", latoa(itf)));
+		freerecvbuf(rb);
+		return -1;
 	}
 
 	/*
@@ -3954,8 +3986,9 @@ select_peerinterface(
 				stoa(srcadr)));
 	} else {
 		ep = dstadr;
-		if (NULL == ep)
+		if (NULL == ep) {
 			ep = wild;
+		}
 	}
 	/*
 	 * If it is a multicast address, findbcastinter() may not find
@@ -3963,16 +3996,19 @@ select_peerinterface(
 	 * given to us as the wildcard (ANY_INTERFACE_CHOOSE).  Either
 	 * way, try a little harder.
 	 */
-	if (wild == ep)
+	if (wild == ep) {
 		ep = findinterface(srcadr);
+	}
 	/*
 	 * we do not bind to the wildcard interfaces for output
 	 * as our (network) source address would be undefined and
 	 * crypto will not work without knowing the own transmit address
 	 */
-	if (ep != NULL && INT_WILDCARD & ep->flags)
-		if (!accept_wildcard_if_for_winnt)
+	if (ep != NULL && (INT_WILDCARD & ep->flags)) {
+		if (!accept_wildcard_if_for_winnt) {
 			ep = NULL;
+		}
+	}
 #else	/* SIM follows */
 	ep = loopback_interface;
 #endif
@@ -4007,7 +4043,7 @@ findinterface(
 
 /*
  * findlocalinterface - find local interface corresponding to addr,
- * which does not have any of flags set.  If bast is nonzero, addr is
+ * which does not have any of flags set.  If bcast is nonzero, addr is
  * a broadcast address.
  *
  * This code attempts to find the local sending address for an outgoing
@@ -4037,21 +4073,21 @@ findlocalinterface(
 	DPRINTF(4, ("Finding interface for addr %s in list of addresses\n",
 		    stoa(addr)));
 
-	/* [Bug 3437] The dummy POOL peer comes in with an AF of
-	 * zero. This is bound to fail, but on the way to nowhere it
+	/* [Bug 3437] The prototype POOL peer can be AF_UNSPEC.
+	 * This is bound to fail, but on the way to nowhere it
 	 * triggers a security incident on SELinux.
 	 *
-	 * Checking the condition and failing early is probably a good
+	 * Checking the condition and failing early is probably good
 	 * advice, and even saves us some syscalls in that case.
 	 * Thanks to Miroslav Lichvar for finding this.
 	 */
-	if (AF_UNSPEC == AF(addr))
+	if (AF_UNSPEC == AF(addr)) {
 		return NULL;
-
+	}
 	s = socket(AF(addr), SOCK_DGRAM, 0);
-	if (INVALID_SOCKET == s)
+	if (INVALID_SOCKET == s) {
 		return NULL;
-
+	}
 	/*
 	 * If we are looking for broadcast interface we need to set this
 	 * socket to allow broadcast
@@ -4092,14 +4128,18 @@ findlocalinterface(
 	 * See http://bugs.ntp.org/1184 and http://bugs.ntp.org/1683
 	 * for more background.
 	 */
-	if (NULL == iface || iface->ignore_packets)
+	if (NULL == iface || iface->ignore_packets) {
 		iface = findclosestinterface(&saddr,
 					     flags | INT_LOOPBACK);
-
-	/* Don't use an interface which will ignore replies */
-	if (iface != NULL && iface->ignore_packets)
+	}
+	/*
+	 * Don't select an interface which will ignore replies, or one
+	 * dedicated to multicast receive.
+	 */
+	if (   iface != NULL
+	    && (iface->ignore_packets || (INT_MCASTIF & iface->flags))) {
 		iface = NULL;
-
+	}
 	return iface;
 }
 
@@ -4169,47 +4209,40 @@ calc_addr_distance(
 	const sockaddr_u *	a2
 	)
 {
-	u_int32	a1val;
-	u_int32	a2val;
-	u_int32	v4dist;
-	int	found_greater;
-	int	a1_greater;
-	int	i;
+	u_char *	pdist;
+	const u_char *	p1;
+	const u_char *	p2;
+	size_t		cb;
+	int		different;
+	int		a1_greater;
+	u_int		u;
 
 	REQUIRE(AF(a1) == AF(a2));
 
 	ZERO_SOCK(dist);
 	AF(dist) = AF(a1);
 
-	/* v4 can be done a bit simpler */
 	if (IS_IPV4(a1)) {
-		a1val = SRCADR(a1);
-		a2val = SRCADR(a2);
-		v4dist = (a1val > a2val)
-			     ? a1val - a2val
-			     : a2val - a1val;
-		SET_ADDR4(dist, v4dist);
-
-		return;
+		pdist = (      u_char *)&NSRCADR(dist);
+		p1 =	(const u_char *)&NSRCADR(a1);
+		p2 =	(const u_char *)&NSRCADR(a2);
+	} else {
+		pdist = (      u_char *)&NSRCADR(dist);
+		p1 =	(const u_char *)&NSRCADR(a1);
+		p2 =	(const u_char *)&NSRCADR(a2);
 	}
-
-	found_greater = FALSE;
-	a1_greater = FALSE;	/* suppress pot. uninit. warning */
-	for (i = 0; i < (int)sizeof(NSRCADR6(a1)); i++) {
-		if (!found_greater &&
-		    NSRCADR6(a1)[i] != NSRCADR6(a2)[i]) {
-			found_greater = TRUE;
-			a1_greater = (NSRCADR6(a1)[i] > NSRCADR6(a2)[i]);
+	cb = SIZEOF_INADDR(AF(dist));
+	different = FALSE;
+	a1_greater = FALSE;
+	for (u = 0; u < cb; u++) {
+		if (!different && p1[u] != p2[u]) {
+			a1_greater = (p1[u] > p2[u]);
+			different = TRUE;
 		}
-		if (!found_greater) {
-			NSRCADR6(dist)[i] = 0;
+		if (a1_greater) {
+			pdist[u] = p1[u] - p2[u];
 		} else {
-			if (a1_greater)
-				NSRCADR6(dist)[i] = NSRCADR6(a1)[i] -
-						    NSRCADR6(a2)[i];
-			else
-				NSRCADR6(dist)[i] = NSRCADR6(a2)[i] -
-						    NSRCADR6(a1)[i];
+			pdist[u] = p2[u] - p1[u];
 		}
 	}
 }
@@ -4468,7 +4501,7 @@ io_closeclock(
 #	    ifdef HAVE_IO_COMPLETION_PORT
 		io_completion_port_remove_clock_io(rio);
 #	    endif
-		close_and_delete_fd_from_list(rio->fd);
+		close_and_delete_fd_from_list(rio->fd, NULL);
 		purge_recv_buffers_for_fd(rio->fd);
 		rio->fd = -1;
 	}
@@ -4503,7 +4536,7 @@ kill_asyncio(
 	maxactivefd = 0;
 
 	while (fd_list != NULL)
-		close_and_delete_fd_from_list(fd_list->fd);
+		close_and_delete_fd_from_list(fd_list->fd, NULL);
 
 	UNBLOCKIO();
 }
@@ -4531,7 +4564,8 @@ add_fd_to_list(
 
 static void
 close_and_delete_fd_from_list(
-	SOCKET fd
+	SOCKET fd,
+	endpt *ep	/* req. if fd is in struct endpt */
 	)
 {
 	vsock_t *lsock;
@@ -4545,6 +4579,11 @@ close_and_delete_fd_from_list(
 	switch (lsock->type) {
 
 	case FD_TYPE_SOCKET:
+	    #ifdef HAVE_IO_COMPLETION_PORT
+		if (ep != NULL) {
+			io_completion_port_remove_socket(fd, ep);
+		}
+	    #endif
 		closesocket(lsock->fd);
 		break;
 
@@ -4635,7 +4674,7 @@ delete_interface_from_list(
 }
 
 
-static struct interface *
+static endpt *
 find_addr_in_list(
 	sockaddr_u *addr
 	)
@@ -4707,7 +4746,7 @@ localaddrtoa(
 static void
 process_routing_msgs(struct asyncio_reader *reader)
 {
-	static char *	buffer;
+	static void *	buffer;
 	static size_t	buffsz = 8192;
 	int		cnt, new, msg_type;
 	socklen_t	len;
@@ -4716,16 +4755,15 @@ process_routing_msgs(struct asyncio_reader *reader)
 #else
 	struct rt_msghdr rtm;
 	char *p;
+	char *endp;
 #endif
 
-	if (disable_dynamic_updates) {
+	if (scan_addrs_once) {
 		/*
 		 * discard ourselves if we are not needed any more
 		 * usually happens when running unprivileged
 		 */
-		remove_asyncio_reader(reader);
-		delete_asyncio_reader(reader);
-		return;
+		goto disable;
 	}
 
 	if (NULL == buffer) {
@@ -4758,22 +4796,20 @@ process_routing_msgs(struct asyncio_reader *reader)
 		    disable:
 			remove_asyncio_reader(reader);
 			delete_asyncio_reader(reader);
+			return;
 		}
-		return;
 	}
 
 	/*
 	 * process routing message
 	 */
 #ifdef HAVE_RTNETLINK
-	for (nh = UA_PTR(struct nlmsghdr, buffer);
-	     NLMSG_OK(nh, cnt);
-	     nh = NLMSG_NEXT(nh, cnt))
+	for (nh = buffer; NLMSG_OK(nh, cnt); nh = NLMSG_NEXT(nh, cnt))
 	{
 		msg_type = nh->nlmsg_type;
 #else
-	for (p = buffer;
-	     (p + sizeof(struct rt_msghdr)) <= (buffer + cnt);
+	for (p = buffer, endp = p + cnt;
+	     (p + sizeof(struct rt_msghdr)) <= endp;
 	     p += rtm.rtm_msglen)
 	{
 		memcpy(&rtm, p, sizeof(rtm));
@@ -4787,7 +4823,7 @@ process_routing_msgs(struct asyncio_reader *reader)
 			return;
 		}
 		msg_type = rtm.rtm_type;
-#endif
+#endif	/* !HAVE_RTNETLINK */
 		switch (msg_type) {
 #ifdef RTM_NEWADDR
 		case RTM_NEWADDR:
@@ -4835,7 +4871,7 @@ process_routing_msgs(struct asyncio_reader *reader)
 			 */
 			DPRINTF(3, ("routing message op = %d: scheduling interface update\n",
 				    msg_type));
-			timer_interfacetimeout(current_time + UPDATE_GRACE);
+			endpt_scan_timer = UPDATE_GRACE + current_time;
 			break;
 #ifdef HAVE_RTNETLINK
 		case NLMSG_DONE:
@@ -4857,14 +4893,14 @@ process_routing_msgs(struct asyncio_reader *reader)
  * set up routing notifications
  */
 static void
-init_async_notifications()
+init_async_notifications(void)
 {
 	struct asyncio_reader *reader;
 #ifdef HAVE_RTNETLINK
 	int fd = socket(PF_NETLINK, SOCK_RAW, NETLINK_ROUTE);
 	struct sockaddr_nl sa;
 #else
-	int fd = socket(PF_ROUTE, SOCK_RAW, 0);
+	int fd = socket(PF_ROUTE, SOCK_RAW, AF_UNSPEC);
 #endif
 	if (fd < 0) {
 		msyslog(LOG_ERR,
@@ -4908,4 +4944,3 @@ init_async_notifications(void)
 {
 }
 #endif
-
diff --git a/contrib/ntp/ntpd/ntp_leapsec.c b/contrib/ntp/ntpd/ntp_leapsec.c
index 88f9d4e1cc23..2618862c57ba 100644
--- a/contrib/ntp/ntpd/ntp_leapsec.c
+++ b/contrib/ntp/ntpd/ntp_leapsec.c
@@ -13,38 +13,16 @@
 #include <sys/stat.h>
 #include <ctype.h>
 
-#include "ntp_types.h"
-#include "ntp_fp.h"
+#include "ntp.h"
 #include "ntp_stdlib.h"
 #include "ntp_calendar.h"
 #include "ntp_leapsec.h"
-#include "ntp.h"
 #include "vint64ops.h"
-#include "lib_strbuf.h"
 
 #include "isc/sha1.h"
 
 static const char * const logPrefix = "leapsecond file";
 
-/* ---------------------------------------------------------------------
- * GCC is rather sticky with its 'const' attribute. We have to do it more
- * explicit than with a cast if we want to get rid of a CONST qualifier.
- * Greetings from the PASCAL world, where casting was only possible via
- * untagged unions...
- */
-static inline void*
-noconst(
-	const void* ptr
-	)
-{
-	union {
-		const void * cp;
-		void *       vp;
-	} tmp;
-	tmp.cp = ptr;
-	return tmp.vp;
-}
-
 /* ---------------------------------------------------------------------
  * Our internal data structure
  */
@@ -84,18 +62,20 @@ static leap_table_t _ltab[2], *_lptr;
 static int/*BOOL*/  _electric;
 
 /* Forward decls of local helpers */
-static int    add_range(leap_table_t*, const leap_info_t*);
-static char * get_line(leapsec_reader, void*, char*, size_t);
-static char * skipws(const char*);
-static int    parsefail(const char * cp, const char * ep);
-static void   reload_limits(leap_table_t*, const vint64*);
-static void   fetch_leap_era(leap_era_t*, const leap_table_t*,
-			     const vint64*);
-static int    betweenu32(uint32_t, uint32_t, uint32_t);
-static void   reset_times(leap_table_t*);
-static int    leapsec_add(leap_table_t*, const vint64*, int);
-static int    leapsec_raw(leap_table_t*, const vint64 *, int, int);
-static const char * lstostr(const vint64 * ts);
+static int		add_range	(leap_table_t *, const leap_info_t *);
+static char *		get_line	(leapsec_reader, void *, char *,
+					 size_t);
+static inline char *	skipws		(char *ptr);
+static int		parsefail	(const char *cp, const char *ep);
+static void		reload_limits	(leap_table_t *, const vint64 *);
+static void		fetch_leap_era	(leap_era_t *, const leap_table_t *,
+					 const vint64 *);
+static int		betweenu32	(u_int32, u_int32, u_int32);
+static void		reset_times	(leap_table_t *);
+static int		leapsec_add	(leap_table_t *, const vint64 *, int);
+static int		leapsec_raw	(leap_table_t *, const vint64 *, int,
+					 int);
+static const char *	lstostr		(const vint64 *ts);
 
 /* =====================================================================
  * Get & Set the current leap table
@@ -178,13 +158,13 @@ leapsec_clear(
  */
 int/*BOOL*/
 leapsec_load(
-	leap_table_t * pt  ,
-	leapsec_reader func,
-	void *         farg,
-	int            use_build_limit)
+	leap_table_t *	pt,
+	leapsec_reader	func,
+	void *		farg,
+	int		use_build_limit
+	)
 {
-	char const	*ep;
-	char		*cp, *endp, linebuf[50];
+	char		*cp, *ep, *endp, linebuf[50];
 	vint64		ttime, limit;
 	long		taiof;
 	struct calendar	build;
@@ -415,7 +395,7 @@ leapsec_reset_frame(void)
 }
 
 /* ------------------------------------------------------------------ */
-/* load a file from a FILE pointer. Note: If hcheck is true, load
+/* load a file from a FILE pointer. Note: If vhash is true, load
  * only after successful signature check. The stream must be seekable
  * or this will fail.
  */
@@ -433,7 +413,7 @@ leapsec_load_stream(
 		fname = "<unknown>";
 
 	if (vhash) {
-		rcheck = leapsec_validate((leapsec_reader)getc, ifp);
+		rcheck = leapsec_validate((leapsec_reader)&getc, ifp);
 		if (logall)
 			switch (rcheck)
 			{
@@ -822,13 +802,15 @@ get_line(
 }
 
 /* [internal] skips whitespace characters from a character buffer. */
-static char *
+static inline char *
 skipws(
-	const char *ptr)
+	char *	ptr
+	)
 {
-	while (isspace((u_char)*ptr))
+	while (isspace((u_char)*ptr)) {
 		ptr++;
-	return (char*)noconst(ptr);
+	}
+	return ptr;
 }
 
 /* [internal] check if a strtoXYZ ended at EOL or whitespace and
@@ -887,7 +869,7 @@ reload_limits(
 
 		if (_electric)
 			pt->head.dtime = pt->head.ttime;
-                else
+		else
 			pt->head.dtime = addv64i32(
 				&pt->head.ttime,
 				pt->head.next_tai - pt->head.this_tai);
diff --git a/contrib/ntp/ntpd/ntp_loopfilter.c b/contrib/ntp/ntpd/ntp_loopfilter.c
index e76e4dce0711..6378e0d7e669 100644
--- a/contrib/ntp/ntpd/ntp_loopfilter.c
+++ b/contrib/ntp/ntpd/ntp_loopfilter.c
@@ -1027,6 +1027,22 @@ rstclock(
 		    tc_counter));
 	if (trans != state && trans != EVNT_FSET)
 		report_event(trans, NULL, NULL);
+#ifdef HAVE_WORKING_FORK
+	if (trans != state && EVNT_SYNC == trans) {
+		/*
+		 * If our parent process is waiting for the
+		 * first clock sync, send them home satisfied.
+		 */
+		if (daemon_pipe[1] != -1) {
+			if (2 != write(daemon_pipe[1], "S\n", 2)) {
+				msyslog(LOG_ERR, "daemon failed to notify parent ntpd (--wait-sync)");
+			}
+			close(daemon_pipe[1]);
+			daemon_pipe[1] = -1;
+		}
+	}
+#endif /* HAVE_WORKING_FORK */
+
 	state = trans;
 	last_offset = clock_offset = offset;
 	clock_epoch = current_time;
diff --git a/contrib/ntp/ntpd/ntp_monitor.c b/contrib/ntp/ntpd/ntp_monitor.c
index b3db452a243e..8af8dff301c4 100644
--- a/contrib/ntp/ntpd/ntp_monitor.c
+++ b/contrib/ntp/ntpd/ntp_monitor.c
@@ -329,9 +329,9 @@ ntp_monitor(
 
 	REQUIRE(rbufp != NULL);
 
-	if (mon_enabled == MON_OFF)
+	if (mon_enabled == MON_OFF) {
 		return ~(RES_LIMITED | RES_KOD) & flags;
-
+	}
 	pkt = &rbufp->recv_pkt;
 	hash = MON_HASH(&rbufp->recv_srcadr);
 	mode = PKT_MODE(pkt->li_vn_mode);
@@ -343,10 +343,11 @@ ntp_monitor(
 	 * otherwise cron'ed ntpdate or similar evades RES_LIMITED.
 	 */
 
-	for (; mon != NULL; mon = mon->hash_next)
-		if (SOCK_EQ(&mon->rmtadr, &rbufp->recv_srcadr))
+	for (; mon != NULL; mon = mon->hash_next) {
+		if (SOCK_EQ(&mon->rmtadr, &rbufp->recv_srcadr)) {
 			break;
-
+		}
+	}
 	if (mon != NULL) {
 		interval_fp = rbufp->recv_time;
 		L_SUB(&interval_fp, &mon->last);
@@ -388,17 +389,17 @@ ntp_monitor(
 		 * the average threshold plus the increment and leave
 		 * the RES_LIMITED and RES_KOD bits lit. Otherwise,
 		 * leave the counter alone and douse the RES_KOD bit.
-		 * This rate-limits the KoDs to no less than the average
-		 * headway.
+		 * This rate-limits the KoDs to no more often than the
+		 * average headway.
 		 */
 		if (interval + 1 >= ntp_minpkt && leak < limit) {
 			mon->leak = leak - 2;
 			restrict_mask &= ~(RES_LIMITED | RES_KOD);
-		} else if (mon->leak < limit)
+		} else if (mon->leak < limit) {
 			mon->leak = limit + head;
-		else
+		} else {
 			restrict_mask &= ~RES_KOD;
-
+		}
 		mon->flags = restrict_mask;
 
 		return mon->flags;
